
    <!DOCTYPE html>
    <html>
      <body>
        <style>@page {
  size: 1280px 720px;
  margin: 0;
}@media print {html, body {
  background-color: #fff;
  margin: 0;
  page-break-inside: avoid;
  break-inside: avoid-page;
}
  div.marpit > section {
    page-break-before: always;
    break-before: page;
  }

  div.marpit > section, div.marpit > section * {
    -webkit-print-color-adjust: exact !important;
    animation-delay: 0s !important;
    animation-duration: 0s !important;
    color-adjust: exact !important;
    transition: none !important;
  }

  div.marpit > svg[data-marpit-svg] {
    display: block;
    height: 100vh;
    width: 100vw;
  }
}

div.marpit > section {
  width: 1280px;
  height: 720px;

  box-sizing: border-box;
  overflow: hidden;
  position: relative;

  scroll-snap-align: center center;
}

div.marpit > section::after {
  bottom: 0;
  content: attr(data-marpit-pagination);
  padding: inherit;
  pointer-events: none;
  position: absolute;
  right: 0;
}

div.marpit > section:not([data-marpit-pagination])::after {
  display: none;
}

/* Normalization */
div.marpit > section h1 {
  font-size: 2em;
  margin: 0.67em 0;
}

div.marpit > section video::-webkit-media-controls {
  will-change: transform;
}</style>
        <div class="marpit"><section id="1" data-marpit-fragments="9">
<h1>Абстракция</h1>
<p>Точка — один из простых геометрических примитивов, который можно расположить на плоскости. Её положение определяется двумя координатами, и в математике она записывается так: (2, 3), где первое число — координата по оси x, а второе — по оси y.</p>
<p>В этом задании нужно создать абстракцию для работы с точкой. Вам предстоит самостоятельно принять решение, о том, как она будет организована.</p>
<h2>scr/main/java/exercise/Point.java</h2>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="1">
<p>Реализуйте следующие публичные статические методы:</p>
<ul>
<li data-marpit-fragment="2"><code>makePoint()</code> — принимает на вход координаты и возвращает точку.</li>
<li data-marpit-fragment="3"><code>getX()</code> — принимает на вход точку и возвращает координату по оси x.</li>
<li data-marpit-fragment="4"><code>getY()</code> — принимает на вход точку и возвращает координату по оси y.</li>
<li data-marpit-fragment="5"><code>pointToString()</code> — принимает на вход точку и возвращает её строковое представление.</li>
<li data-marpit-fragment="6"><code>getQuadrant()</code> — принимает на вход точку и возвращает номер квадранта, в котором эта точка расположена. Если точка не принадлежит ни одному квадранту (лежит на оси координат), то функция должна возвращать 0.</li>
</ul>
</li>
</ul>
<pre><code class="language-java">int[] point = Point.makePoint(3, 4);
Point.getX(point); // 3
Point.getY(point); // 4
Point.pointToString(point); // &quot;(3, 4)&quot;

Point.getQuadrant(point); // 1
int[] point2 = makePoint(3, -3);
Point.getQuadrant(point2); // 4
int[] point3 = makePoint(0, 7);
Point.getQuadrant(point3); // 0
</code></pre>
<h2>Подсказки</h2>
<ul>
<li data-marpit-fragment="7">Схема, показывающая номера квадрантов на плоскости.</li>
</ul>
<pre><code>           +
         2 | 1
           |
- ---------------+
           |
         3 | 4
           -
</code></pre>
<h2>Самостоятельная работа</h2>
<ul>
<li data-marpit-fragment="8">Реализуйте публичный статический метод <code>getSymmetricalPointByX()</code>. Метод принимает в качестве аргумента точку и возвращает новую точку, симметричную исходной относительно оси Х.</li>
</ul>
<pre><code class="language-java">int[] point = App.makePoint(-3, -6);
int[] symmetricalPoint = App.getSymmetricalPointByX(point);
Point.pointToString(symmetricalPoint); // (-3, 6)
</code></pre>
<ul>
<li data-marpit-fragment="9">Реализуйте публичный статический метод <code>calculateDistance()</code>. Метод принимает в качестве аргументов две точки и возвращает расстояние между этими точками.</li>
</ul>
<pre><code class="language-java">int[] point1 = App.makePoint(0, 0);
int[] point1 = App.makePoint(3, 4);
Point.calculateDistance(point1, point2); // 5
</code></pre>
</section>
</div>
      </body>
    </html>
  